/******************************************************************************
 * C-BUNG 06
 * Dateioperationen
 *           
 * (c) 2003, by Jan Iversen und Andreas Schibilla
 *****************************************************************************/
#include "sometools.h"
#include "sqlfile.h"
#include "ueb06.h"



/******************************************************************************
 * Gibt die Hilfe und einen Info-String aus, danach wird das Programm mit
 * errorcode beendet
 *****************************************************************************/
void usage(char * str, int errorcode)
{
 printf("Usage: ueb06 [-h] [-d] [-s] [-f] [-fa] [-w] [-wa] [-wo] ...\n%s\n", str);

 ende(errorcode);
}



/******************************************************************************
 *
 *****************************************************************************/
void suchehilfe(int argc, char * argv[])
{
 int i;

 for (i=1; i<argc; ++i)
   if (strcicmp(argv[i], "-h"))
      usage("-> Hilfeparameter wurde angegeben!\n", 0 /*argc!=2*/);
}


/******************************************************************************
 *
 *****************************************************************************/
int param(char *s)
{
 return
 strcicmp(s, "-d")    ||
 strcicmp(s, "-s")    ||
 strcicmp(s, "-f")    ||
 strcicmp(s, "-fa")   ||
 strcicmp(s, "-w")    ||
 strcicmp(s, "-wa")   ||
 strcicmp(s, "-wo");
}


/******************************************************************************
 *
 *****************************************************************************/
int istparam(char *s, char *para)
{
 int ret=1;

 if (strcicmp(para, "-w") || strcicmp(para, "-wa")  || strcicmp(para, "-wo"))
   {
    return !param(s);
   }

 while (*s && ret)
   {
/*             ((*s > 64) && (*s < 91)  ) ||
             ((*s > 96) && (*s < 123) ) ||
             (*s == ' ')                ||
             (*s == '=');*/
/*	     printf("-w\n");*/
      ret =  ((*s > 64) && (*s < 91)  ) ||
             ((*s > 96) && (*s < 123) );
/*      printf("para: %s", para);
      printf("ret: %d", ret);
      printf("s: %s\n", s);*/
      s++;
   }
 return ret;
}





/******************************************************************************
 *
 *****************************************************************************/
int check_d(int argc, char *argv[], int *i, int *dgefunden, char * dateiname)
{
 if( strcicmp(argv[*i],"-d") )
   {
      if (*dgefunden)
            usage("-> Dateinamen-Tag mehrfach angegeben!\n", 1);

      if ( (argc-*i-1) < 1)
            usage("-> Kein Dateiname nach -d angegeben!\n", 1);

      strcpy(dateiname, argv[*i+1]);

      *i += 2;
      return *dgefunden = 1;
   }
 return 0;
}


/******************************************************************************
 * gibt anzahl der argumente einschlielich -x parameter zurck
 *****************************************************************************/
int argumente(int argc, char *argv[], int *i, char * parg)
{
 int pos = 1;

 while ( ((*i+pos) < argc) && (istparam(argv[*i+pos], argv[*i])) )       /* erfordert nicht strikte auswertung */
         {

            if (  strcicmp(argv[*i], "-wo") )
               strcat(parg, "\nOR ");
            else
            if (  strcicmp(argv[*i], "-wa") )
               strcat(parg, "\nAND ");
            else
            if (*parg != '\0' )
               strcat(parg, TRENNZEICHEN);


            strcat(parg, argv[*i+pos]);
            ++pos;
         }
 *i += pos;
 return pos-1;
}


/******************************************************************************
 *
 *****************************************************************************/
int keinebed(char *s)
{
 int len = strlen(s);
 return (len<3) || (s[0]=='=') || (s[len-1]=='=') || (strstr(s,"=")==NULL);
}


/******************************************************************************
 *
 *****************************************************************************/
int checkpara(int argc, char *argv[], int *i, char * para, int *gefunden, char * parg)
{
 char    buf[50]     = "";
 int     count       = 0;

 if( strcicmp(argv[*i], para) )
   {

      /* Parameter mehrfach angegeben */
      if ( (gefunden!=NULL) && (*gefunden) )
            {
               sprintf(buf, "-> '%s'-Tag mehrfach angegeben!\n", para);
               usage(buf, 1);
            }

      count = argumente(argc, argv, i, parg);

      switch(count)
         {
            case 0:  /* kein Argument an Parameter bergeben */
                     if (strcicmp(para, "-s")  )   strcat(parg, "*");
                     if (strcicmp(para, "-f")  )   usage("Kein Argument zum From-Parameter angegeben!\n", 1);
                     if (strcicmp(para, "-fa") )   usage("Kein Argument zum FromAdd-Parameter angegeben!\n", 1);
                     if (strcicmp(para, "-w")  )   usage("Kein Argument zum Where-Parameter angegeben!\n", 1);
                     if (strcicmp(para, "-wa") )   usage("Kein Argument zum WhereAnd-Parameter angegeben!\n", 1);
                     if (strcicmp(para, "-wo") )   usage("Kein Argument zum WhereOr-Parameter angegeben!\n", 1);
                     break;

            case 1:  /* ein Argument an Parameter bergeben */
                     /* gltige Bedingung ? */
                     if (strcicmp(para, "-w")  && keinebed(argv[*i-1]) ) usage("-> Where-Bedingung ungueltig!\n", 1);
                     if (strcicmp(para, "-wa") && keinebed(argv[*i-1]) ) usage("-> WhereAnd-Bedingung ungueltig!\n", 1);
                     if (strcicmp(para, "-wo") && keinebed(argv[*i-1]) ) usage("-> WhereOr-Bedingung ungueltig!\n", 1);

                     break;

            default: /* mehrere Argumente an Parameter bergeben */
                     if (strcicmp(para, "-w")  )   usage("-> Zu viele Parameter nach Where-Tag!\n", 1);
                     if (strcicmp(para, "-wa") )   usage("-> Zu viele Parameter nach WhereAnd-Tag!\n", 1);
                     if (strcicmp(para, "-wo") )   usage("-> Zu viele Parameter nach WhereOr-Tag!\n", 1);
                     break;
         }

      if (gefunden != NULL)
         *gefunden = 1;

      return 1;
   }
 return 0;
}



/******************************************************************************
 * Hauptfkt. konstruiert SQL-Querys
 *
 * -> argc     - Wieviele Paramter
 * -> argv     - Array mit den Kommandozeilenparamtern als Strings
 *
 * Die Fkt. gibt Returncode an Betriebssystem zurck
 *****************************************************************************/
int main (int argc, char * argv[])
{
 int     i=1;
 int     sgefunden=0, fgefunden=0, wgefunden=0, dgefunden=0;
 SQL     sql            = { "", "", "" };
 SQL     sqlpara        = { "", "", "" };
 char    dateiname[MAXFILENAME] = "";
 char    fromadd[MAXDLINELEN]  = "";
 char    whereadd[MAXDLINELEN] = "";


  /* keine Parameter an Programm */
 if (argc<=1)
     usage("-> Keine Parameter angegeben\n", 0);

 /* irgendwo ein Hilfe-Parameter */
 suchehilfe(argc, argv);


 /* --- Parameter parsen --- */
 while (i<argc)
 {
   if ( check_d(argc, argv, &i, &dgefunden, dateiname) )                         continue;
   if ( checkpara(argc, argv, &i, "-s", &sgefunden, sqlpara.pselect ) )          continue;
   if ( checkpara(argc, argv, &i, "-f", &fgefunden, sqlpara.pfrom ) )            continue;
   if ( checkpara(argc, argv, &i, "-fa", NULL, fromadd) )                        continue;
   if ( checkpara(argc, argv, &i, "-w", &wgefunden, sqlpara.pwhere) )            continue;
   if ( checkpara(argc, argv, &i, "-wa", NULL, whereadd) )                       continue;
   if ( checkpara(argc, argv, &i, "-wo", NULL, whereadd) )                       continue;

   usage("-> Ungueltiger Parameter angegeben!\n", 1);
 }


 if (!dgefunden)
   usage("-> Kein Dateiname angebeben!\n",1);



 /* --- Datei auslesen und alle Werte einlesen/vorinitialisieren --- */
 dateieinlesen(dateiname, &sql);


 /* --- Parameter mit Dateiinhalt kombinieren --- */


 /* Select prfen */

 if ( (sql.pselect[0] == '\0') && (sqlpara.pselect[0] == '\0') )     /* kein Select in Datei und Params */
      usage("-> Kein Select gefunden!\n", 1);

 if ( (sqlpara.pselect[0] != '\0') )                                 /* wenn Select angegeben wurde */
      {
         strcpy(sql.pselect, SELECT_TEXT);                           /* ersetze den Datei-Wert */
         strcat(sql.pselect, sqlpara.pselect);
      }


 /* From prfen */
 if ( (sql.pfrom[0] == '\0') && (sqlpara.pfrom[0] == '\0') )         /* kein From in Datei und Params */
      usage("-> Kein From gefunden!\n", 1);

 if ( (sqlpara.pfrom[0] != '\0') )                                   /* wenn From angegeben wurde */
      {
         strcpy(sql.pfrom, FROM_TEXT);                               /* ersetze den Datei-Wert */
         strcat(sql.pfrom, sqlpara.pfrom);
      }

 if ( fromadd[0] != '\0' )                                           /* wenn FromAdd angegeben */
      {
         strcat(sql.pfrom, TRENNZEICHEN);
         strcat(sql.pfrom, fromadd);                                 /* Fge den Wert hinzu */
      }



 /* Where prfen */
 if ( (sql.pwhere[0] == '\0') && (sqlpara.pwhere[0] == '\0') )       /* kein Where in Datei und Params */
      usage("-> Kein Where gefunden!\n", 1);

 if ( (sqlpara.pwhere[0] != '\0') )                                  /* wenn Where angegeben wurde */
      {
         strcpy(sql.pwhere, WHERE_TEXT);                             /* ersetze den Datei-Wert */
         strcat(sql.pwhere, sqlpara.pwhere);
      }

 if ( whereadd[0] != '\0' )                                          /* wenn WhereAdd angegeben */
      {
         strcat(sql.pwhere, whereadd);                               /* Fge den Wert hinzu */
      }

 strcat(sql.pwhere, ";");


 /* --- speichern des Ergebnisses aus der sql-Struktur --- */
 dateispeichern(dateiname, &sql);

 /* gebe das Ergebniss auch auf Bildschirm */
 printf("%s\n%s\n%s\n", sql.pselect, sql.pfrom, sql.pwhere);


 ende(0);
}



